import { __assign, __values } from "tslib";
import * as statistics from './util/statistics';
import { partition } from './util/partition';
import { assert } from './util/helper';
/**
 *
 * @param rows - 数据
 * @param options - 参数
 *
 * @public
 */
export function aggregate(rows, options) {
    var e_1, _a;
    var fields = options.fields, op = options.op;
    fields && assert(Array.isArray(fields), "Invalid fields: it must be an array with one or more strings!");
    !fields &&
        assert(op.every(function (item) { return item === 'count'; }), "operations must all be 'count' when fields is empty");
    assert(op.length === options.as.length, "Invalid as: it's length must be the same as operations!");
    var groups = partition(rows, options.groupBy);
    var results = [];
    var _loop_1 = function (group) {
        var result = __assign({}, group[0]);
        op.forEach(function (operation, i) {
            var outputName = options.as[i];
            var field = fields ? fields[i] : undefined;
            result[outputName] = statistics[operation](field ? group.map(function (item) { return item[field]; }) : group);
        });
        results.push(result);
    };
    try {
        for (var _b = __values(Object.values(groups)), _c = _b.next(); !_c.done; _c = _b.next()) {
            var group = _c.value;
            _loop_1(group);
        }
    }
    catch (e_1_1) { e_1 = { error: e_1_1 }; }
    finally {
        try {
            if (_c && !_c.done && (_a = _b.return)) _a.call(_b);
        }
        finally { if (e_1) throw e_1.error; }
    }
    return results;
}
