import { typeAll, isUnique } from '@antv/dw-analyzer';
import { parse } from './parse';
/**
 * @beta
 */
export function autoTransform(data) {
    var result = {
        result: [],
        schemas: [],
    };
    var schema = {
        actions: [],
    };
    var dataAnalyze = typeAll(data);
    var toGroupBy = [];
    var toNotGroupBy = [];
    dataAnalyze.forEach(function (col) {
        if (col.recommendation === 'string' && !isUnique(col)) {
            toGroupBy.push(col.name);
        }
        else {
            toNotGroupBy.push(col.name);
        }
    });
    if (toGroupBy.length) {
        schema.groupBy = toGroupBy;
        toNotGroupBy.forEach(function (colName) {
            schema.actions.push({
                type: 'sum',
                field: colName,
                as: "SUM(" + colName + ")",
            });
        });
        result.schemas.push(schema);
    }
    result.result = parse(data, result.schemas);
    return result;
}
