import { __read, __spread } from "tslib";
/**
 * 合并默认值
 * @param options - 需要初始化的对象
 * @param defaults - 默认值
 */
export function mergeOptions(options, defaults) {
    var result = Object.assign({}, defaults);
    Object.entries(options).forEach(function (_a) {
        var _b = __read(_a, 2), key = _b[0], value = _b[1];
        if (value !== undefined) {
            result[key] = value;
        }
    });
    return result;
}
export function getExtent(arr) {
    return [Math.min.apply(Math, __spread(arr)), Math.max.apply(Math, __spread(arr))];
}
/**
 * 断言
 * @param test - 需要断言的内容
 * @param errorMessage - 错误信息
 */
export function assert(condition, msg) {
    if (!condition) {
        throw new Error(msg);
    }
}
export function getSequence(start, stop, step) {
    var s;
    if (step) {
        if (start > stop) {
            assert(step < 0, 'xxx');
        }
        if (start < stop) {
            assert(step > 0, 'xxx');
        }
        s = step;
    }
    else {
        s = start < stop ? 1 : -1;
    }
    var result = [];
    var i = 0;
    while (true) {
        var value = start + i * s;
        if (s > 0 && value >= stop)
            break;
        if (s < 0 && value <= stop)
            break;
        result.push(value);
        i++;
    }
    return result;
}
