"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var tslib_1 = require("tslib");
var statistics = tslib_1.__importStar(require("./util/statistics"));
var partition_1 = require("./util/partition");
var helper_1 = require("./util/helper");
/**
 *
 * @param rows - 数据
 * @param options - 参数
 *
 * @public
 */
function aggregate(rows, options) {
    var e_1, _a;
    var fields = options.fields, op = options.op;
    fields && helper_1.assert(Array.isArray(fields), "Invalid fields: it must be an array with one or more strings!");
    !fields &&
        helper_1.assert(op.every(function (item) { return item === 'count'; }), "operations must all be 'count' when fields is empty");
    helper_1.assert(op.length === options.as.length, "Invalid as: it's length must be the same as operations!");
    var groups = partition_1.partition(rows, options.groupBy);
    var results = [];
    var _loop_1 = function (group) {
        var result = tslib_1.__assign({}, group[0]);
        op.forEach(function (operation, i) {
            var outputName = options.as[i];
            var field = fields ? fields[i] : undefined;
            result[outputName] = statistics[operation](field ? group.map(function (item) { return item[field]; }) : group);
        });
        results.push(result);
    };
    try {
        for (var _b = tslib_1.__values(Object.values(groups)), _c = _b.next(); !_c.done; _c = _b.next()) {
            var group = _c.value;
            _loop_1(group);
        }
    }
    catch (e_1_1) { e_1 = { error: e_1_1 }; }
    finally {
        try {
            if (_c && !_c.done && (_a = _b.return)) _a.call(_b);
        }
        finally { if (e_1) throw e_1.error; }
    }
    return results;
}
exports.aggregate = aggregate;
