"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var dw_analyzer_1 = require("@antv/dw-analyzer");
var parse_1 = require("./parse");
/**
 * @beta
 */
function autoTransform(data) {
    var result = {
        result: [],
        schemas: [],
    };
    var schema = {
        actions: [],
    };
    var dataAnalyze = dw_analyzer_1.typeAll(data);
    var toGroupBy = [];
    var toNotGroupBy = [];
    dataAnalyze.forEach(function (col) {
        if (col.recommendation === 'string' && !dw_analyzer_1.isUnique(col)) {
            toGroupBy.push(col.name);
        }
        else {
            toNotGroupBy.push(col.name);
        }
    });
    if (toGroupBy.length) {
        schema.groupBy = toGroupBy;
        toNotGroupBy.forEach(function (colName) {
            schema.actions.push({
                type: 'sum',
                field: colName,
                as: "SUM(" + colName + ")",
            });
        });
        result.schemas.push(schema);
    }
    result.result = parse_1.parse(data, result.schemas);
    return result;
}
exports.autoTransform = autoTransform;
